Subject: Re: [PATCH v6] format-patch --signature-file <file>

From: Junio C Hamano <[email-masked]>
Date: Wed, 21 May 2014 14:58:42 -0700

Jeremiah Mahler <[email-masked]> writes:

> On Wed, May 21, 2014 at 02:13:06PM -0700, Junio C Hamano wrote:
>> Jeremiah Mahler <[email-masked]> writes:
>> 
> ...
>> >  	! grep "^-- \$" output
> ...
>> 
>> We have been trying not to do the above in recent test updates.  It
>> would be nice if this set-up did not have to be outside of the usual
>> test_expect_success structure.
>> 
>
> Jeff caught those "! grep" instances in my patch.

Hmm, I didn't mean that one, and I do not offhand what is wrong
about "! grep" that says "output should not contain this string".

The problem is a "cat" you added outside test_expect_*; the recent
push is to have as little executable outside them, especially the
"set-up" code to prepare for the real tests.

i.e. we have been trying to write new tests (and convert old ones)
like this:

        test_expect_success 'I test such and such ' '
                cat >input-for-test <<-\EOF &&
                here comes input
                EOF
                git command-to-be-tested <input-for-test >actual &&
                cat >expected <<-\EOF &&
                here comes expected output
                EOF
                test_cmp expected actual
        '

not like this:

        cat >input-for-test <<-\EOF &&
        here comes input
        EOF
        test_expect_success 'I test such and such ' '
                git command-to-be-tested <input-for-test >actual &&
                cat >expected <<-\EOF &&
                here comes expected output
                EOF
                test_cmp expected actual
        '